require 'rubygems'
require 'graphviz'

class Point

  attr_reader :node
  def initialize (n,g,parent)
    @n = n
    @node = g.add_node(n.to_s)
    g.add_edge(@node,parent.node) if parent
  end
  def next(g,nodes)
    nodes.push(Point.new(@n*2,g,self))
    if @n > 15 and @n % 3 == 1 and (@n-1)/3 %2 != 0
      nodes.push(Point.new((@n-1)/3,g,self))
    end
 end
end

def makegraph (g,nodes)
  new_nodes = Array.new
  nodes.size.times{|n|
    nodes[n].next(g,new_nodes)
  } 
  return new_nodes
end

g = GraphViz::new("G",{:type => "digraph", :use => "dot", :output => "png", :file => "collatz.png"})
p1 = Point.new(1,g,nil) 
nodes = [p1]
12.times{
  nodes = makegraph(g,nodes)
}
g.output()

